/*
 * LoggerAgent.java
 *
 * Created on 31.10.2014
 *
 * Copyright (C) 2014 Volkswagen AG, All rights reserved.
 */

package com.pratikprogramci.jvm.agent;

import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.lang.instrument.Instrumentation;
import java.security.ProtectionDomain;

import javassist.ClassPool;
import javassist.CtClass;
import javassist.CtMethod;

public class LoggerAgent implements ClassFileTransformer {

    public static void premain(final String agentArguments, final Instrumentation instrumentation) {
        instrumentation.addTransformer(new LoggerAgent());
    }

    public byte[] transform(final ClassLoader classloader, final String className, final Class<?> clazz,
            final ProtectionDomain domain, final byte[] bytes) throws IllegalClassFormatException {

        if (className.equals("com/pratikprogramci/jvm/agent/HelloWorld")) {
            try {

                System.out.println(">>Bytecode enjeksiyonu basliyor.....");

                final ClassPool cp = ClassPool.getDefault();
                final CtClass cc = cp.get("com.pratikprogramci.jvm.agent.HelloWorld");
                final CtMethod m = cc.getDeclaredMethod("run");
                m.addLocalVariable("executionTime", CtClass.longType);

                m.insertBefore("executionTime = System.currentTimeMillis();");
                m.insertAfter("{executionTime = System.currentTimeMillis() - " + "executionTime;"
                        + "System.out.println(\">>Metot \" + executionTime + " + "\" ms icinde tamamlandi.\" );}");

                final byte[] byteCode = cc.toBytecode();
                cc.detach();
                return byteCode;

            } catch (final Exception ex) {
                ex.printStackTrace();
            }
        }
        return null;
    }
}
